function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end

function string.split(text,b)
local cmd = {}
if b then
b = b
else
b = "%s"
end
b = "[^"..b.."]+"
for o in string.gmatch(text,b) do
table.insert(cmd,o)
end
return cmd
end

function totable(t,match)
     local cmd = {}
     if not match then match = "[^%s]+" end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end 

elo=initArray(32)

addhook("ms100","hud")
function hud()
	for id=1,32 do
		if elo[id]==0 then
			elo[id]=1200
		end
		parse('hudtxt2 '..id..' 1 "050100155Elo: '..elo[id]..' " 13 117')
		show_rank(id)
	end
end

addhook("kill","elo_inc")
function elo_inc(id,vic)
	if id~=vic then	
		local dif=0
		dif=1/(1+10^((elo[id]-elo[vic])/400))
		dif=math.ceil(dif*10)
		elo[id]=elo[id]+dif
		elo[vic]=elo[vic]-dif
		parse('hudtxt2 '..id..' 30 "050100155Elo: You gained '..dif..' ELO-Rating " 13 150')
		parse('hudtxt2 '..vic..' 30 "050100155Elo: You lost '..dif..' ELO-Rating " 13 150')
		parse('hudtxtalphafade '..id..' 30 3500 0.0')
		parse('hudtxtalphafade '..vic..' 30 3500 0.0')
	end
end

addhook("leave","save_leave")
function save_leave(id)
	save(id)
end

function save(id)
     if (player(id,"usgn")>0) then
          io.output(io.open("sys/lua/elo/"..player(id,"usgn")..".txt","w+"))
          io.write(elo[id])
          io.close()
     end
end

addhook("team","load_join")
function load_join(id)
	if (player(id,"usgn")>0) then
		local filename = "sys/lua/elo/%s.txt"
		local file = io.open(filename:format(player(id,"usgn"), "r"))
		local line
		if not file then
			line = {0, 1}
			msg2(id,"255000000Failed to save!@C")
		else
			line = file:read("*a"):split()
		end
		elo[id] = tonumber(line[1]) or 1200		-- If line[1] is not a number, ELO becomes 1
		msg2(id,"050100155ELO: Welcome back, "..player(id,"name").."!")
		msg2(id,"050100155ELO: Your USID is "..player(id,"usgn").."!")
		msg2(id,"050100155ELO: Loading successful!")
	else
		elo[id]=1200
	end
end

addhook("serveraction","sa")
function sa(id,b)
	if b==1 then
		menu(id,"ELO@b,Reset ELO-Statistic|Resets your ELO to the basic amount (1200)")
	end
end

addhook("menu","sa_menu")
function sa_menu(id,t,b)
	if t=="ELO" then
		if b==1 then
			menu(id,"Reset ELO@b,You really want to reset your ELO!?|Yes,I want to stay my ELO|No")
		end
	elseif t=="Reset ELO" then
		if b==1 then
			elo[id]=1200
			save(id)
			msg2(id,"050100155ELO: You successfully reset your ELO, good luck!")
		end
	end
end

function show_rank(id)
	if elo[id]<=1200 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Beginner " 13 130')
	elseif elo[id]<=1350 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Amateur " 13 130')
	elseif elo[id]<=1550 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Intermediate " 13 130')
	elseif elo[id]<=1800 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Pro " 13 130')
	elseif elo[id]<=2000 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Expert " 13 130')
	elseif elo[id]<=2250 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Grandmaster " 13 130')
	elseif elo[id]>=2400 then
		parse('hudtxt2 '..id..' 2 "050100155Title: Ultimate Grandmaster " 13 130')
	end
end

addhook("say","title")
function title(id,txt)
	if txt~="stats" then
		if elo[id]<=1200 then
			msg("255193193"..player(id,"name").." [Beginner]: "..txt)
			return 1
		elseif elo[id]<=1350 then
			msg("238180180"..player(id,"name").." [Amateur]: "..txt)
			return 1
		elseif elo[id]<=1550 then
			msg("255064064"..player(id,"name").." [Intermediate]: "..txt)
			return 1
		elseif elo[id]<=1800 then
			msg("255127036"..player(id,"name").." [Pro]: "..txt)
			return 1
		elseif elo[id]<=2000 then
			msg("139090043"..player(id,"name").." [Expert]: "..txt)
			return 1
		elseif elo[id]<=2250 then
			msg("255069000"..player(id,"name").." [Grandmaster]: "..txt)
			return 1
		elseif elo[id]>=2400 then
			msg("238048048"..player(id,"name").." [Ult. Grandmaster]: "..txt)
			return 1
		end
	else
		msg("238048048"..player(id,"name").."'s ELO-Rating is: "..elo[id].."!")
		return 1
	end
end